//+---------------------------------------------------------------------------+
//|                                                        mv-i-TAACH_2_0.mq4 |
//|                                                  . MaxV42 |
//|                                                http://                    |
//|     "".                                   |
//+---------------------------------------------------------------------------+
//|  2.0  27.12.2009                                                  |
//| :                                                                |
//|  -     .                                     |
//+---------------------------------------------------------------------------+
//|  1.0  20.12.2009                                                  |
//+---------------------------------------------------------------------------+
#property copyright "  . MaxV42"
#property link      "http://"
//+---------------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1
#property indicator_color3 Blue
#property indicator_color4 Red
#property indicator_width3 1
#property indicator_width4 1
//+---------------------------------------------------------------------------+
extern string Ind_Coment1="---    ---";
extern bool  ShowFractals_LowerTF      = false;    // /  
extern bool  OnAlert_Pitchfork_LowerTF = false;    // /     
extern int   nPitchfork_Upper_LowerTF  =     2;    //    " "
extern int   nPitchfork_Lower_LowerTF  =     2;    //    " "
extern bool  ShowPitchfork_LowerTF     = false;    // / " "  
extern string Ind_Coment2="---    ---";
extern int   TF_Upper                  =   240;    //  
extern bool  ShowFractals_UpperTF      = false;    // /  
extern bool  OnAlert_Pitchfork_UpperTF = false;    // /     
extern int   nPitchfork_Upper_UpperTF  =     1;    //    " "
extern int   nPitchfork_Lower_UpperTF  =     1;    //    " "
extern bool  ShowPitchfork_UpperTF     = false;    // / " "  
//+---------------------------------------------------------------------------+
//  
int          nBars_LowerTF             =     0,    // -   
nBars_UpperTF             =     0;    // -   
int          QntPitchfork_Upper_LowerTF=     0;    //     " "
int          QntPitchfork_Lower_LowerTF=     0;    //     " "
int          QntPitchfork_Upper_UpperTF=     0;    //     " "
int          QntPitchfork_Lower_UpperTF=     0;    //     " "
//+---------------------------------------------------------------------------+
extern string Ind_Coment3="---    ---";
extern bool  ShowChannels              =  true;    // /    
extern bool  ShowChannels_LowerTF      =  true;    // /   
extern bool  ShowChannels_UpperTF      =  true;    // /   
extern int   nChannels_LowerTF         =     2;    // -   
extern int   nChannels_UpperTF         =     1;    // -   
extern color Channels_Color0           = DodgerBlue;  //  0 
extern color Channels_Color1           =      Green;  //  1 
extern color Channels_Color2           =    Magenta;  //  2 
extern color Channels_Color3           =       Peru;  //  3 
extern color Channels_Color4           =      Black;  //   
//+---------------------------------------------------------------------------+
//  
int QntChannels_LowerTF = 0,                       // -     
QntChannels_UpperTF = 0;                       // -     
string       mChannels_LowerTF[][8];               //      
                                                   //  mChannels_LowerTF[i][0]               // 0-   2-    
// 1-   2-    
// 2-   2-    
// 3-   2-    
//  mChannels_LowerTF[i][1]               //     
//  mChannels_LowerTF[i][2]               //      
//  mChannels_LowerTF[i][3]               //     
//  mChannels_LowerTF[i][4]               //      
//  mChannels_LowerTF[i][5]               //    
//  mChannels_LowerTF[i][6]               //     
//  mChannels_LowerTF[i][7]               //  
string       mChannels_UpperTF[][8];               //      
                                                   //  mChannels_UpperTF[i][0]               // 0-   2-    
// 1-   2-    
// 2-   2-    
// 3-   2-    
//  mChannels_UpperTF[i][1]               //     
//  mChannels_UpperTF[i][2]               //      
//  mChannels_UpperTF[i][3]               //     
//  mChannels_UpperTF[i][4]               //      
//  mChannels_UpperTF[i][5]               //    
//  mChannels_UpperTF[i][6]               //     
//  mChannels_UpperTF[i][7]               //  
//----- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
//+---------------------------------------------------------------------------+
void init() 
  {        // Custom indicator initialization function
   int    Qnt=ObjectsTotal();
// ----- Indicators Properties
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,119);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,119);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,117);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,117);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
// ----- Name for DataWindow and indicator subwindow label
   IndicatorShortName("mv-i-TAACH_2_0");
   SetIndexLabel(0,"FractalsUp_LowerTF");
   SetIndexLabel(1,"FractalsDown_LowerTF");
   SetIndexLabel(2,"FractalsUp_UpperTF");
   SetIndexLabel(3,"FractalsDown_UpperTF");
// -----      
   ArrayResize(mChannels_LowerTF,nChannels_LowerTF); ArrayResize(mChannels_UpperTF,nChannels_UpperTF);

   return;
  }
//+---------------------------------------------------------------------------+
void deinit() 
  {     // Custom indicator deinitialization function
   int    Qnt=ObjectsTotal();
// -----   
   for(int i=0; i<Qnt; i++) 
     {  //   
      if(StringFind(ObjectName(i),"Pitchfork_Upper",0)>=0) 
        {
         ObjectDelete(ObjectName(i));     //  
         i--; continue;
        }
      if(StringFind(ObjectName(i),"Pitchfork_Lower",0)>=0) 
        {
         ObjectDelete(ObjectName(i));     //  
         i--; continue;
        }
      if(StringFind(ObjectName(i),"Channel",0)>=0) 
        {
         ObjectDelete(ObjectName(i));     //  
         i--; continue;
        }
      if(i>=ObjectsTotal()) break;
     }
   return;
  }
//+---------------------------------------------------------------------------+
void start() 
  {        // Custom indicator iteration function
   int    counted_bars=IndicatorCounted();
   int    limit;
   int    Spred=(int)MarketInfo(Symbol(),MODE_SPREAD);
   double Fractals_Upper=0,Fractals_Lower=0;
// -----    
   if(!CheckParameters()) return;
// -----    
   if(!isNewBar_LowerTF()) return;
// -----     
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars; if(limit>500) limit=500;
// -----  
   for(int i=limit; i>=0; i--) 
     {
      //--------------------------------------------------------- 1 --
      Fractals_Upper=iFractals(NULL,0,MODE_UPPER,i);
      Fractals_Lower=iFractals(NULL,0,MODE_LOWER,i);
      // -----     
      if(Fractals_Upper>0) 
        {
         // -----    " "
         if(!ShowChannels) 
           {
            // -----       " "
            if(ShowPitchfork_LowerTF) 
              {
               if(DrawLowerPitchfork(i,0)) 
                 {
                  // -----  
                  if(OnAlert_Pitchfork_LowerTF && i==0) 
                    {
                     Alert(Symbol(),Period(),"   ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
                    }
                 }
              }
           }
         // -----    ""
         if(ShowChannels) 
           {
            // -----      ""
            if(ShowChannels_LowerTF) 
              {
               CheckUpperPoints(i,0);
              }
           }
         // -----    
         if(ShowFractals_LowerTF) 
           {
            ExtMapBuffer1[i]=Fractals_Upper+Spred*Point;
           }
        }
      // -----     
      if(Fractals_Lower>0) 
        {
         // -----    " "
         if(!ShowChannels) 
           {
            // -----       " "
            if(ShowPitchfork_LowerTF) 
              {
               if(DrawUpperPitchfork(i,0)) 
                 {
                  // -----  
                  if(OnAlert_Pitchfork_LowerTF && i==0) 
                    {
                     Alert(Symbol(),Period(),"   ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
                    }
                 }
              }
           }
         // -----    ""
         if(ShowChannels) 
           {
            // -----      ""
            if(ShowChannels_LowerTF) 
              {
               CheckLowerPoints(i,0);
              }
           }
         // -----    
         if(ShowFractals_LowerTF) 
           {
            ExtMapBuffer2[i]=Fractals_Lower-Spred*Point;
           }
        }
      //--------------------------------------------------------- 2 --
      Fractals_Upper=0;Fractals_Lower=0;
      //--------------------------------------------------------- 3 --
      // -----     
      if(isNewBar_UpperTF(Time[i])) 
        {
         Fractals_Upper=iFractals(NULL,TF_Upper,MODE_UPPER,nBars_UpperTF);
         Fractals_Lower=iFractals(NULL,TF_Upper,MODE_LOWER,nBars_UpperTF);
         // -----     
         if(Fractals_Upper>0) 
           {
            // -----    " "
            if(!ShowChannels) 
              {
               // -----       " "
               if(ShowPitchfork_UpperTF) 
                 {
                  if(DrawLowerPitchfork(nBars_UpperTF,TF_Upper)) 
                    {
                     // -----  
                     if(OnAlert_Pitchfork_UpperTF && nBars_UpperTF==0) 
                       {
                        Alert(Symbol(),Period(),"   ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
                       }
                    }
                 }
              }
            // -----    ""
            if(ShowChannels) 
              {
               // -----      ""
               if(ShowChannels_UpperTF) 
                 {
                  CheckUpperPoints(nBars_UpperTF,TF_Upper);
                 }
              }
            // -----    
            if(ShowFractals_UpperTF) 
              {
               ExtMapBuffer3[iBarShift(NULL,0,iTime(NULL,TF_Upper,nBars_UpperTF),false)]=Fractals_Upper+Spred*Point;
              }
           }
         // -----     
         if(Fractals_Lower>0) 
           {
            // -----    " "
            if(!ShowChannels) 
              {
               // -----       " "
               if(ShowPitchfork_UpperTF) 
                 {
                  if(DrawUpperPitchfork(nBars_UpperTF,TF_Upper)) 
                    {
                     // -----  
                     if(OnAlert_Pitchfork_UpperTF && nBars_UpperTF==0) 
                       {
                        Alert(Symbol(),Period(),"   ! ",TimeToStr(Time[i],TIME_DATE|TIME_SECONDS));
                       }
                    }
                 }
              }
            // -----    ""
            if(ShowChannels) 
              {
               // -----      ""
               if(ShowChannels_UpperTF) 
                 {
                  CheckLowerPoints(nBars_UpperTF,TF_Upper);
                 }
              }
            // -----    
            if(ShowFractals_UpperTF) 
              {
               ExtMapBuffer4[iBarShift(NULL,0,iTime(NULL,TF_Upper,nBars_UpperTF),false)]=Fractals_Lower-Spred*Point;
              }
           }
        }

     }

   return;
  }
//+---------------------------------------------------------------------------+
bool isNewBar_LowerTF() 
  {  //   true,       
   if(nBars_LowerTF!=Bars) 
     {
      nBars_LowerTF=Bars; return(true);
     }
   return(false);
  }
//+---------------------------------------------------------------------------+
bool isNewBar_UpperTF(datetime DateTime_) 
  {  //   true,       
   if(nBars_UpperTF!=iBarShift(NULL,TF_Upper,DateTime_,false)) 
     {
      nBars_UpperTF=iBarShift(NULL,TF_Upper,DateTime_,false); return(true);
     }
   return(false);
  }
//+---------------------------------------------------------------------------+
bool CheckParameters() 
  {     //     
   string TextMessage;
   if(nPitchfork_Upper_LowerTF<1 || nPitchfork_Lower_LowerTF<1 || 
      nPitchfork_Upper_UpperTF<1 || nPitchfork_Lower_UpperTF<1) 
     {
      TextMessage="    !"+
                  "     <() 1";
      Alert(TextMessage);
      return(false);
     }
   if(TF_Upper<=Period()) 
     {
      TextMessage="    !"+
                  "     >() !";
      Alert(TextMessage);
      return(false);
     }

   return(true);
  }
//+-------------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+
//+------------------------------------------     ------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+

//+---------------------------------------------------------------------------+
bool DrawUpperPitchfork(int nBar,int TF=0) 
  {  //      " "
   double Fractals_Upper=0,Fractals_Lower=0;
   string mFractals[3][3];
   int i,j=0;
//--------------------------------------------------------- I --
// -----   
   for(i=nBar; i<Bars; i++) 
     {  //   
      Fractals_Upper=iFractals(NULL,TF,MODE_UPPER,i);
      Fractals_Lower=iFractals(NULL,TF,MODE_LOWER,i);
      // ----- !      
      if(j<3 && Fractals_Lower>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Lower,Digits);
         mFractals[j][2]=(string)-1;
         j++;
        }
      if(j<3 && Fractals_Upper>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Upper,Digits);
         mFractals[j][2]=(string)1;
         j++;
        }
      if(j>3) break;
     }
//-------------------------------------------------------- II --
// ------    : MODE_LOWER->MODE_UPPER->MODE_LOWER
   if(StrToDouble(mFractals[0][2])==-1 && StrToDouble(mFractals[1][2])==1 && StrToDouble(mFractals[2][2])==-1) 
     {
      //--------------------------------------------------------- 1 --
      // -----  
      if(TF==0) 
        {
         if(QntPitchfork_Upper_LowerTF<nPitchfork_Upper_LowerTF) 
           {  // -   ,   
            ObjectCreate("Pitchfork_Upper_LowerTF"+(string)QntPitchfork_Upper_LowerTF,OBJ_PITCHFORK,0,
                         StrToTime(mFractals[2][0]),StrToDouble(mFractals[2][1]),
                         StrToTime(mFractals[1][0]),StrToDouble(mFractals[1][1]),
                         StrToTime(mFractals[0][0]),StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)QntPitchfork_Upper_LowerTF,OBJPROP_COLOR,Red);
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)QntPitchfork_Upper_LowerTF,OBJPROP_STYLE,STYLE_DASH);
            QntPitchfork_Upper_LowerTF++;
           }
         if(QntPitchfork_Upper_LowerTF>=nPitchfork_Upper_LowerTF) 
           {  // -  ,    
            for(i=0; i<=QntPitchfork_Upper_LowerTF-2; i++) 
              {
               ObjectSet("Pitchfork_Upper_LowerTF"+(string)i,OBJPROP_TIME1,ObjectGet("Pitchfork_Upper_LowerTF"+(string)(i+1),OBJPROP_TIME1));
               ObjectSet("Pitchfork_Upper_LowerTF"+(string)i,OBJPROP_PRICE1,ObjectGet("Pitchfork_Upper_LowerTF"+(string)(i+1),OBJPROP_PRICE1));
               ObjectSet("Pitchfork_Upper_LowerTF"+(string)i,OBJPROP_TIME2,ObjectGet("Pitchfork_Upper_LowerTF"+(string)(i+1),OBJPROP_TIME2));
               ObjectSet("Pitchfork_Upper_LowerTF"+(string)i,OBJPROP_PRICE2,ObjectGet("Pitchfork_Upper_LowerTF"+(string)(i+1),OBJPROP_PRICE2));
               ObjectSet("Pitchfork_Upper_LowerTF"+(string)i,OBJPROP_TIME3,ObjectGet("Pitchfork_Upper_LowerTF"+(string)(i+1),OBJPROP_TIME3));
               ObjectSet("Pitchfork_Upper_LowerTF"+(string)i,OBJPROP_PRICE3,ObjectGet("Pitchfork_Upper_LowerTF"+(string)(i+1),OBJPROP_PRICE3));
              }
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_TIME1,StrToTime(mFractals[2][0]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_PRICE1,StrToDouble(mFractals[2][1]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_TIME2,StrToTime(mFractals[1][0]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_PRICE2,StrToDouble(mFractals[1][1]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_TIME3,StrToTime(mFractals[0][0]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_PRICE3,StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Upper_LowerTF"+(string)(QntPitchfork_Upper_LowerTF-1),OBJPROP_STYLE,STYLE_SOLID);
           }
        }
      //--------------------------------------------------------- 2 --
      // -----  
      if(TF!=0) 
        {
         if(QntPitchfork_Upper_UpperTF<nPitchfork_Upper_UpperTF) 
           {  // -   ,   
            ObjectCreate("Pitchfork_Upper_UpperTF"+(string)QntPitchfork_Upper_UpperTF,OBJ_PITCHFORK,0,
                         StrToTime(mFractals[2][0]),StrToDouble(mFractals[2][1]),
                         StrToTime(mFractals[1][0]),StrToDouble(mFractals[1][1]),
                         StrToTime(mFractals[0][0]),StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)QntPitchfork_Upper_UpperTF,OBJPROP_COLOR,Red);
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)QntPitchfork_Upper_UpperTF,OBJPROP_STYLE,STYLE_DASH);
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)QntPitchfork_Upper_UpperTF,OBJPROP_WIDTH,2);
            QntPitchfork_Upper_UpperTF++;
           }
         if(QntPitchfork_Upper_UpperTF>=nPitchfork_Upper_UpperTF) 
           {  // -  ,    
            for(i=0; i<=QntPitchfork_Upper_UpperTF-2; i++) 
              {
               ObjectSet("Pitchfork_Upper_UpperTF"+(string)i,OBJPROP_TIME1,ObjectGet("Pitchfork_Upper_UpperTF"+(string)(i+1),OBJPROP_TIME1));
               ObjectSet("Pitchfork_Upper_UpperTF"+(string)i,OBJPROP_PRICE1,ObjectGet("Pitchfork_Upper_UpperTF"+(string)(i+1),OBJPROP_PRICE1));
               ObjectSet("Pitchfork_Upper_UpperTF"+(string)i,OBJPROP_TIME2,ObjectGet("Pitchfork_Upper_UpperTF"+(string)(i+1),OBJPROP_TIME2));
               ObjectSet("Pitchfork_Upper_UpperTF"+(string)i,OBJPROP_PRICE2,ObjectGet("Pitchfork_Upper_UpperTF"+(string)(i+1),OBJPROP_PRICE2));
               ObjectSet("Pitchfork_Upper_UpperTF"+(string)i,OBJPROP_TIME3,ObjectGet("Pitchfork_Upper_UpperTF"+(string)(i+1),OBJPROP_TIME3));
               ObjectSet("Pitchfork_Upper_UpperTF"+(string)i,OBJPROP_PRICE3,ObjectGet("Pitchfork_Upper_UpperTF"+(string)(i+1),OBJPROP_PRICE3));
              }
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_TIME1,StrToTime(mFractals[2][0]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_PRICE1,StrToDouble(mFractals[2][1]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_TIME2,StrToTime(mFractals[1][0]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_PRICE2,StrToDouble(mFractals[1][1]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_TIME3,StrToTime(mFractals[0][0]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_PRICE3,StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Upper_UpperTF"+(string)(QntPitchfork_Upper_UpperTF-1),OBJPROP_STYLE,STYLE_SOLID);
           }
        }
      return(true);
     }
   return(false);
  }
//+---------------------------------------------------------------------------+
bool DrawLowerPitchfork(int nBar,int TF=0) 
  {  //      " "
   double Fractals_Upper=0,Fractals_Lower=0;
   string mFractals[3][3];
   int i,j=0;
//--------------------------------------------------------- I --
// -----   
   for(i=nBar; i<Bars; i++) 
     {  //   
      Fractals_Upper=iFractals(NULL,TF,MODE_UPPER,i);
      Fractals_Lower=iFractals(NULL,TF,MODE_LOWER,i);
      // ----- !      
      if(j<3 && Fractals_Upper>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Upper,Digits);
         mFractals[j][2]=(string)1;
         j++;
        }
      if(j<3 && Fractals_Lower>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Lower,Digits);
         mFractals[j][2]=(string)-1;
         j++;
        }
      if(j>3) break;
     }
//-------------------------------------------------------- II --
// ------    : MODE_UPPER->MODE_LOWER->MODE_UPPER
   if(StrToDouble(mFractals[0][2])==1 && StrToDouble(mFractals[1][2])==-1 && StrToDouble(mFractals[2][2])==1) 
     {
      //--------------------------------------------------------- 1 --
      // -----  
      if(TF==0) 
        {
         if(QntPitchfork_Lower_LowerTF<nPitchfork_Lower_LowerTF) 
           {  // -   ,   
            ObjectCreate("Pitchfork_Lower_LowerTF"+(string)QntPitchfork_Lower_LowerTF,OBJ_PITCHFORK,0,
                         StrToTime(mFractals[2][0]),StrToDouble(mFractals[2][1]),
                         StrToTime(mFractals[1][0]),StrToDouble(mFractals[1][1]),
                         StrToTime(mFractals[0][0]),StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)QntPitchfork_Lower_LowerTF,OBJPROP_COLOR,Blue);
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)QntPitchfork_Lower_LowerTF,OBJPROP_STYLE,STYLE_DASH);
            QntPitchfork_Lower_LowerTF++;
           }
         if(QntPitchfork_Lower_LowerTF>=nPitchfork_Lower_LowerTF) 
           {  // -  ,    
            for(i=0; i<=QntPitchfork_Lower_LowerTF-2; i++) 
              {
               ObjectSet("Pitchfork_Lower_LowerTF"+(string)i,OBJPROP_TIME1,ObjectGet("Pitchfork_Lower_LowerTF"+(string)(i+1),OBJPROP_TIME1));
               ObjectSet("Pitchfork_Lower_LowerTF"+(string)i,OBJPROP_PRICE1,ObjectGet("Pitchfork_Lower_LowerTF"+(string)(i+1),OBJPROP_PRICE1));
               ObjectSet("Pitchfork_Lower_LowerTF"+(string)i,OBJPROP_TIME2,ObjectGet("Pitchfork_Lower_LowerTF"+(string)(i+1),OBJPROP_TIME2));
               ObjectSet("Pitchfork_Lower_LowerTF"+(string)i,OBJPROP_PRICE2,ObjectGet("Pitchfork_Lower_LowerTF"+(string)(i+1),OBJPROP_PRICE2));
               ObjectSet("Pitchfork_Lower_LowerTF"+(string)i,OBJPROP_TIME3,ObjectGet("Pitchfork_Lower_LowerTF"+(string)(i+1),OBJPROP_TIME3));
               ObjectSet("Pitchfork_Lower_LowerTF"+(string)i,OBJPROP_PRICE3,ObjectGet("Pitchfork_Lower_LowerTF"+(string)(i+1),OBJPROP_PRICE3));
              }
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_TIME1,StrToTime(mFractals[2][0]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_PRICE1,StrToDouble(mFractals[2][1]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_TIME2,StrToTime(mFractals[1][0]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_PRICE2,StrToDouble(mFractals[1][1]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_TIME3,StrToTime(mFractals[0][0]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_PRICE3,StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Lower_LowerTF"+(string)(QntPitchfork_Lower_LowerTF-1),OBJPROP_STYLE,STYLE_SOLID);
           }
        }
      //--------------------------------------------------------- 2 --
      // -----  
      if(TF!=0) 
        {
         if(QntPitchfork_Lower_UpperTF<nPitchfork_Lower_UpperTF) 
           {  // -   ,   
            ObjectCreate("Pitchfork_Lower_UpperTF"+(string)QntPitchfork_Lower_UpperTF,OBJ_PITCHFORK,0,
                         StrToTime(mFractals[2][0]),StrToDouble(mFractals[2][1]),
                         StrToTime(mFractals[1][0]),StrToDouble(mFractals[1][1]),
                         StrToTime(mFractals[0][0]),StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)QntPitchfork_Lower_UpperTF,OBJPROP_COLOR,Blue);
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)QntPitchfork_Lower_UpperTF,OBJPROP_STYLE,STYLE_DASH);
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)QntPitchfork_Lower_UpperTF,OBJPROP_WIDTH,2);
            QntPitchfork_Lower_UpperTF++;
           }
         if(QntPitchfork_Lower_UpperTF>=nPitchfork_Lower_UpperTF) 
           {  // -  ,    
            for(i=0; i<=QntPitchfork_Lower_UpperTF-2; i++) 
              {
               ObjectSet("Pitchfork_Lower_UpperTF"+(string)i,OBJPROP_TIME1,ObjectGet("Pitchfork_Lower_UpperTF"+(string)(i+1),OBJPROP_TIME1));
               ObjectSet("Pitchfork_Lower_UpperTF"+(string)i,OBJPROP_PRICE1,ObjectGet("Pitchfork_Lower_UpperTF"+(string)(i+1),OBJPROP_PRICE1));
               ObjectSet("Pitchfork_Lower_UpperTF"+(string)i,OBJPROP_TIME2,ObjectGet("Pitchfork_Lower_UpperTF"+(string)(i+1),OBJPROP_TIME2));
               ObjectSet("Pitchfork_Lower_UpperTF"+(string)i,OBJPROP_PRICE2,ObjectGet("Pitchfork_Lower_UpperTF"+(string)(i+1),OBJPROP_PRICE2));
               ObjectSet("Pitchfork_Lower_UpperTF"+(string)i,OBJPROP_TIME3,ObjectGet("Pitchfork_Lower_UpperTF"+(string)(i+1),OBJPROP_TIME3));
               ObjectSet("Pitchfork_Lower_UpperTF"+(string)i,OBJPROP_PRICE3,ObjectGet("Pitchfork_Lower_UpperTF"+(string)(i+1),OBJPROP_PRICE3));
              }
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_TIME1,StrToTime(mFractals[2][0]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_PRICE1,StrToDouble(mFractals[2][1]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_TIME2,StrToTime(mFractals[1][0]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_PRICE2,StrToDouble(mFractals[1][1]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_TIME3,StrToTime(mFractals[0][0]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_PRICE3,StrToDouble(mFractals[0][1]));
            ObjectSet("Pitchfork_Lower_UpperTF"+(string)(QntPitchfork_Lower_UpperTF-1),OBJPROP_STYLE,STYLE_SOLID);
           }
        }
      return(true);
     }
   return(false);
  }
//+-------------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+
//+--------------------------------------------    --------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------------------------------------+

//+---------------------------------------------------------------------------+
color GetChannelColor(int Index) 
  {  //      
   switch(Index) 
     {
      case 0:
         return(Channels_Color0);
      case 1:
         return(Channels_Color1);
      case 2:
         return(Channels_Color2);
      case 3:
         return(Channels_Color3);
     }
   return(Channels_Color4);
  }
//+---------------------------------------------------------------------------+
bool CheckUpperPoints(int nBar,int TF=0) 
  {  //       
   double Fractals_Upper=0,Fractals_Lower=0;
   string mFractals[3][3];
   int i,j=0;
//--------------------------------------------------------- I --
// -----   
   for(i=nBar; i<Bars; i++) 
     {  //   
      Fractals_Upper=iFractals(NULL,TF,MODE_UPPER,i);
      Fractals_Lower=iFractals(NULL,TF,MODE_LOWER,i);
      // ----- !      
      if(j<3 && Fractals_Upper>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Upper,Digits);
         mFractals[j][2]=(string)1;
         j++;
        }
      if(j<3 && Fractals_Lower>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Lower,Digits);
         mFractals[j][2]=(string)-1;
         j++;
        }
      if(j>3) break;
     }
//-------------------------------------------------------- II --
// ------    : MODE_UPPER->MODE_LOWER->MODE_UPPER
   if(StrToDouble(mFractals[0][2])==1 && StrToDouble(mFractals[1][2])==-1 && StrToDouble(mFractals[2][2])==1) 
     {
      //--------------------------------------------------------- 1 --
      // -----  
      if(TF==0) 
        {
         if(QntChannels_LowerTF<nChannels_LowerTF) 
           {// -   ,  
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF][0]=(string)0;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF][0]=(string)1;  //    2-    
            mChannels_LowerTF[QntChannels_LowerTF][1]=mFractals[2][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF][2]=mFractals[2][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF][3]=mFractals[1][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF][4]=mFractals[1][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF][5]=mFractals[0][0];  //    
            mChannels_LowerTF[QntChannels_LowerTF][6]=mFractals[0][1];  //     
            QntChannels_LowerTF++;
            // -----  
            CheckQntChannels(0,false);
           }
         if(QntChannels_LowerTF>=nChannels_LowerTF) 
           {// -  ,   
            for(i=0; i<nChannels_LowerTF-1; i++) 
              {
               mChannels_LowerTF[i][0]=mChannels_LowerTF[i+1][0];  //  
               mChannels_LowerTF[i][1]=mChannels_LowerTF[i+1][1];  //     
               mChannels_LowerTF[i][2]=mChannels_LowerTF[i+1][2];  //      
               mChannels_LowerTF[i][3]=mChannels_LowerTF[i+1][3];  //     
               mChannels_LowerTF[i][4]=mChannels_LowerTF[i+1][4];  //      
               mChannels_LowerTF[i][5]=mChannels_LowerTF[i+1][5];  //    
               mChannels_LowerTF[i][6]=mChannels_LowerTF[i+1][6];  //     
               mChannels_LowerTF[i][7]=mChannels_LowerTF[i+1][7];  //  
              }
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF-1][0]=(string)0;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF-1][0]=(string)1;  //    2-    
            mChannels_LowerTF[QntChannels_LowerTF-1][1]=mFractals[2][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF-1][2]=mFractals[2][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF-1][3]=mFractals[1][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF-1][4]=mFractals[1][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF-1][5]=mFractals[0][0];  //    
            mChannels_LowerTF[QntChannels_LowerTF-1][6]=mFractals[0][1];  //     
                                                                          // -----  
            CheckQntChannels(0,true);
           }
        }
      //--------------------------------------------------------- 2 --
      // -----  
      if(TF!=0) 
        {
         if(QntChannels_UpperTF<nChannels_UpperTF) 
           {// -   ,  
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF][0]=(string)0;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF][0]=(string)1;  //    2-    
            mChannels_UpperTF[QntChannels_UpperTF][1]=mFractals[2][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF][2]=mFractals[2][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF][3]=mFractals[1][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF][4]=mFractals[1][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF][5]=mFractals[0][0];  //    
            mChannels_UpperTF[QntChannels_UpperTF][6]=mFractals[0][1];  //            
            QntChannels_UpperTF++;
            // -----  
            CheckQntChannels(TF_Upper,false);
           }
         if(QntChannels_UpperTF>=nChannels_UpperTF) 
           {// -  ,   
            for(i=0; i<nChannels_UpperTF-1; i++) 
              {
               mChannels_UpperTF[i][0]=mChannels_UpperTF[i+1][0];  //  
               mChannels_UpperTF[i][1]=mChannels_UpperTF[i+1][1];  //     
               mChannels_UpperTF[i][2]=mChannels_UpperTF[i+1][2];  //      
               mChannels_UpperTF[i][3]=mChannels_UpperTF[i+1][3];  //     
               mChannels_UpperTF[i][4]=mChannels_UpperTF[i+1][4];  //      
               mChannels_UpperTF[i][5]=mChannels_UpperTF[i+1][5];  //    
               mChannels_UpperTF[i][6]=mChannels_UpperTF[i+1][6];  //     
               mChannels_UpperTF[i][7]=mChannels_UpperTF[i+1][7];  //  
              }
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF-1][0]=(string)0;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF-1][0]=(string)1;  //    2-    
            mChannels_UpperTF[QntChannels_UpperTF-1][1]=mFractals[2][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF-1][2]=mFractals[2][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF-1][3]=mFractals[1][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF-1][4]=mFractals[1][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF-1][5]=mFractals[0][0];  //    
            mChannels_UpperTF[QntChannels_UpperTF-1][6]=mFractals[0][1];  //     
                                                                          // -----  
            CheckQntChannels(TF_Upper,true);
           }
        }
      return(true);
     }
   return(false);
  }
//+---------------------------------------------------------------------------+
bool CheckLowerPoints(int nBar,int TF=0) 
  {  //       
   double Fractals_Upper=0,Fractals_Lower=0;
   string mFractals[3][3];
   int i,j=0;
//--------------------------------------------------------- 1 --
// -----   
   for(i=nBar; i<Bars; i++) 
     {  //   
      Fractals_Upper=iFractals(NULL,TF,MODE_UPPER,i);
      Fractals_Lower=iFractals(NULL,TF,MODE_LOWER,i);
      // ----- !      
      if(j<3 && Fractals_Lower>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Lower,Digits);
         mFractals[j][2]=(string)-1;
         j++;
        }
      if(j<3 && Fractals_Upper>0) 
        {
         mFractals[j][0]=TimeToStr(iTime(NULL,TF,i),TIME_DATE|TIME_MINUTES);
         mFractals[j][1]=DoubleToStr(Fractals_Upper,Digits);
         mFractals[j][2]=(string)1;
         j++;
        }
      if(j>3) break;
     }
//--------------------------------------------------------- 2 --
// ------    : MODE_LOWER->MODE_UPPER->MODE_LOWER
   if(StrToDouble(mFractals[0][2])==-1 && StrToDouble(mFractals[1][2])==1 && StrToDouble(mFractals[2][2])==-1) 
     {
      //--------------------------------------------------------- 1 --
      // -----  
      if(TF==0) 
        {
         if(QntChannels_LowerTF<nChannels_LowerTF) 
           {// -   ,  
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF][0]=(string)2;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF][0]=(string)3;  //    2-    
            mChannels_LowerTF[QntChannels_LowerTF][1]=mFractals[2][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF][2]=mFractals[2][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF][3]=mFractals[1][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF][4]=mFractals[1][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF][5]=mFractals[0][0];  //    
            mChannels_LowerTF[QntChannels_LowerTF][6]=mFractals[0][1];  //     
            QntChannels_LowerTF++;
            // -----  
            CheckQntChannels(0,false);
           }
         if(QntChannels_LowerTF>=nChannels_LowerTF) 
           {// -  ,   
            for(i=0; i<nChannels_LowerTF-1; i++) 
              {
               mChannels_LowerTF[i][0]=mChannels_LowerTF[i+1][0];  //  
               mChannels_LowerTF[i][1]=mChannels_LowerTF[i+1][1];  //     
               mChannels_LowerTF[i][2]=mChannels_LowerTF[i+1][2];  //      
               mChannels_LowerTF[i][3]=mChannels_LowerTF[i+1][3];  //     
               mChannels_LowerTF[i][4]=mChannels_LowerTF[i+1][4];  //      
               mChannels_LowerTF[i][5]=mChannels_LowerTF[i+1][5];  //    
               mChannels_LowerTF[i][6]=mChannels_LowerTF[i+1][6];  //     
               mChannels_LowerTF[i][7]=mChannels_LowerTF[i+1][7];  //  
              }
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF-1][0]=(string)2;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_LowerTF[QntChannels_LowerTF-1][0]=(string)3;  //    2-    
            mChannels_LowerTF[QntChannels_LowerTF-1][1]=mFractals[2][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF-1][2]=mFractals[2][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF-1][3]=mFractals[1][0];  //     
            mChannels_LowerTF[QntChannels_LowerTF-1][4]=mFractals[1][1];  //      
            mChannels_LowerTF[QntChannels_LowerTF-1][5]=mFractals[0][0];  //    
            mChannels_LowerTF[QntChannels_LowerTF-1][6]=mFractals[0][1];  //     
                                                                          // -----  
            CheckQntChannels(0,true);
           }
        }
      //--------------------------------------------------------- 2 --
      // -----  
      if(TF!=0) 
        {
         if(QntChannels_UpperTF<nChannels_UpperTF) 
           {// -   ,  
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF][0]=(string)2;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF][0]=(string)3;  //    2-    
            mChannels_UpperTF[QntChannels_UpperTF][1]=mFractals[2][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF][2]=mFractals[2][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF][3]=mFractals[1][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF][4]=mFractals[1][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF][5]=mFractals[0][0];  //    
            mChannels_UpperTF[QntChannels_UpperTF][6]=mFractals[0][1];  //            
            QntChannels_UpperTF++;
            // -----  
            CheckQntChannels(TF_Upper,false);
           }
         if(QntChannels_UpperTF>=nChannels_UpperTF) 
           {// -  ,   
            for(i=0; i<nChannels_UpperTF-1; i++) 
              {
               mChannels_UpperTF[i][0]=mChannels_UpperTF[i+1][0];  //  
               mChannels_UpperTF[i][1]=mChannels_UpperTF[i+1][1];  //     
               mChannels_UpperTF[i][2]=mChannels_UpperTF[i+1][2];  //      
               mChannels_UpperTF[i][3]=mChannels_UpperTF[i+1][3];  //     
               mChannels_UpperTF[i][4]=mChannels_UpperTF[i+1][4];  //      
               mChannels_UpperTF[i][5]=mChannels_UpperTF[i+1][5];  //    
               mChannels_UpperTF[i][6]=mChannels_UpperTF[i+1][6];  //     
               mChannels_UpperTF[i][7]=mChannels_UpperTF[i+1][7];  //  
              }
            if(StrToDouble(mFractals[2][1])<StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF-1][0]=(string)2;  //    2-    
            if(StrToDouble(mFractals[2][1])>=StrToDouble(mFractals[0][1]))
               mChannels_UpperTF[QntChannels_UpperTF-1][0]=(string)3;  //    2-    
            mChannels_UpperTF[QntChannels_UpperTF-1][1]=mFractals[2][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF-1][2]=mFractals[2][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF-1][3]=mFractals[1][0];  //     
            mChannels_UpperTF[QntChannels_UpperTF-1][4]=mFractals[1][1];  //      
            mChannels_UpperTF[QntChannels_UpperTF-1][5]=mFractals[0][0];  //    
            mChannels_UpperTF[QntChannels_UpperTF-1][6]=mFractals[0][1];  //     
                                                                          // -----  
            CheckQntChannels(TF_Upper,true);
           }
        }
      return(true);
     }
   return(false);
  }
//+---------------------------------------------------------------------------+
void CheckQntChannels(int TF=0,bool ReDraw=false) 
  {  //      
   int Index=0,i=0;
   string Channels_Name="";
//--------------------------------------------------------- 1 --
// -----      FALSE
   if(!ReDraw)  
     {
      if(TF==0) 
        {         // -----  
         Index=QntChannels_LowerTF-1;
        }
      if(TF!=0) 
        {         // -----  
         Index=QntChannels_UpperTF-1;
        }
      // -----   
      DrawChannels(TF,Index);
     }

//--------------------------------------------------------- 2 --
// -----      TRUE -   
   if(ReDraw) 
     {
      if(TF==0) 
        {         // -----  
         Index=QntChannels_LowerTF-1;
         Channels_Name="Channel_LowerTF";
        }
      if(TF!=0) 
        {         // -----  
         Index=QntChannels_UpperTF-1;
         Channels_Name="Channel_UpperTF";
        }
      int Qnt=ObjectsTotal();
      // -----      
      for(i=0; i<Qnt; i++) 
        {  //   
         if(StringFind(ObjectName(i),Channels_Name,0)>=0) 
           {
            ObjectDelete(ObjectName(i));
            i--; continue;
           }
         if(i>=ObjectsTotal()) break;
        }
      for(i=0; i<=Index; i++) 
        {
         // -----   
         DrawChannels(TF,i);
        }
     }
   return;
  }
//+---------------------------------------------------------------------------+
void DrawChannels(int TF=0,int Index=0) 
  {  //      

//--------------------------------------------------------- 1 --
   if(TF==0) 
     {         // -----  
      // -----    2-    
      if(StrToDouble(mChannels_LowerTF[Index][0])==0 || StrToDouble(mChannels_LowerTF[Index][0])==1) 
        {
         // -----  ( ) 
         ObjectCreate("Channel_LowerTF"+(string)Index+"_UpperLine",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2]),
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6]));
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLine",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLine",OBJPROP_WIDTH,3);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----   
         mChannels_LowerTF[Index][7]=(string)(ObjectGetValueByShift("Channel_LowerTF"+(string)Index+"_UpperLine",iBarShift(NULL,0,StrToTime(mChannels_LowerTF[Index][3])))
                                     -StrToDouble(mChannels_LowerTF[Index][4]));
         // -----   
         ObjectCreate("Channel_LowerTF"+(string)Index+"_LowerLine",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][3]),StrToDouble(mChannels_LowerTF[Index][4]),
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7]));
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLine",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    
         ObjectCreate("Channel_LowerTF"+(string)Index+".MiddleLine",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2])
                      -StrToDouble(mChannels_LowerTF[Index][7])/2,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])/2);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2])
                      -StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][3]),StrToDouble(mChannels_LowerTF[Index][4])
                      +StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])+
                      StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2])
                      +StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])+StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][3]),StrToDouble(mChannels_LowerTF[Index][4])
                      -StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])-
                      StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
        }
      // -----    2-    
      if(StrToDouble(mChannels_LowerTF[Index][0])==2 || StrToDouble(mChannels_LowerTF[Index][0])==3) 
        {
         // -----  ( ) 
         ObjectCreate("Channel_LowerTF"+(string)Index+"_LowerLine",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2]),
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6]));
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLine",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLine",OBJPROP_WIDTH,3);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----   
         mChannels_LowerTF[Index][7]=(string)(ObjectGetValueByShift("Channel_LowerTF"+(string)Index+"_LowerLine",iBarShift(NULL,0,StrToTime(mChannels_LowerTF[Index][3])))
                                     -StrToDouble(mChannels_LowerTF[Index][4]));
         // -----   
         ObjectCreate("Channel_LowerTF"+(string)Index+"_UpperLine",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][3]),StrToDouble(mChannels_LowerTF[Index][4]),
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7]));
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLine",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    
         ObjectCreate("Channel_LowerTF"+(string)Index+".MiddleLine",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2])
                      -StrToDouble(mChannels_LowerTF[Index][7])/2,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])/2);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+".MiddleLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2])
                      -StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][3]),StrToDouble(mChannels_LowerTF[Index][4])
                      +StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])+
                      StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][1]),StrToDouble(mChannels_LowerTF[Index][2])
                      +StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])+StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_LowerTF[Index][3]),StrToDouble(mChannels_LowerTF[Index][4])
                      -StrToDouble(mChannels_LowerTF[Index][7])/10,
                      StrToTime(mChannels_LowerTF[Index][5]),StrToDouble(mChannels_LowerTF[Index][6])-StrToDouble(mChannels_LowerTF[Index][7])-
                      StrToDouble(mChannels_LowerTF[Index][7])/10);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_LowerTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
        }
     }
//--------------------------------------------------------- 2 --
   if(TF!=0) 
     {         // -----  
      // -----    2-    
      if(StrToDouble(mChannels_UpperTF[Index][0])==0 || StrToDouble(mChannels_UpperTF[Index][0])==1) 
        {
         // -----  ( ) 
         ObjectCreate("Channel_UpperTF"+(string)Index+"_UpperLine",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2]),
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6]));
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLine",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLine",OBJPROP_WIDTH,3);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----   
         mChannels_UpperTF[Index][7]=(string)(ObjectGetValueByShift("Channel_UpperTF"+(string)Index+"_UpperLine",iBarShift(NULL,0,StrToTime(mChannels_UpperTF[Index][3])))
                                     -StrToDouble(mChannels_UpperTF[Index][4]));
         // -----   
         ObjectCreate("Channel_UpperTF"+(string)Index+"_LowerLine",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][3]),StrToDouble(mChannels_UpperTF[Index][4]),
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7]));
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLine",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    
         ObjectCreate("Channel_UpperTF"+(string)Index+".MiddleLine",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2])
                      -StrToDouble(mChannels_UpperTF[Index][7])/2,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])/2);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2])
                      -StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][3]),StrToDouble(mChannels_UpperTF[Index][4])
                      +StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])+
                      StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2])
                      +StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])+StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][3]),StrToDouble(mChannels_UpperTF[Index][4])
                      -StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])-
                      StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
        }
      // -----    2-    
      if(StrToDouble(mChannels_UpperTF[Index][0])==2 || StrToDouble(mChannels_UpperTF[Index][0])==3) 
        {
         // -----  ( ) 
         ObjectCreate("Channel_UpperTF"+(string)Index+"_LowerLine",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2]),
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6]));
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLine",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLine",OBJPROP_WIDTH,3);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----   
         mChannels_UpperTF[Index][7]=(string)(ObjectGetValueByShift("Channel_UpperTF"+(string)Index+"_LowerLine",iBarShift(NULL,0,StrToTime(mChannels_UpperTF[Index][3])))
                                     -StrToDouble(mChannels_UpperTF[Index][4]));
         // -----   
         ObjectCreate("Channel_UpperTF"+(string)Index+"_UpperLine",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][3]),StrToDouble(mChannels_UpperTF[Index][4]),
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7]));
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLine",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    
         ObjectCreate("Channel_UpperTF"+(string)Index+".MiddleLine",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2])
                      -StrToDouble(mChannels_UpperTF[Index][7])/2,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])/2);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+".MiddleLine",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2])
                      -StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    -10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][3]),StrToDouble(mChannels_UpperTF[Index][4])
                      +StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])+
                      StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(-10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][1]),StrToDouble(mChannels_UpperTF[Index][2])
                      +StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])+StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_LowerLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
         // -----    +10%
         ObjectCreate("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJ_TREND,0,StrToTime(mChannels_UpperTF[Index][3]),StrToDouble(mChannels_UpperTF[Index][4])
                      -StrToDouble(mChannels_UpperTF[Index][7])/10,
                      StrToTime(mChannels_UpperTF[Index][5]),StrToDouble(mChannels_UpperTF[Index][6])-StrToDouble(mChannels_UpperTF[Index][7])-
                      StrToDouble(mChannels_UpperTF[Index][7])/10);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_RAY,True);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_STYLE,STYLE_DASH);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_WIDTH,1);
         ObjectSet("Channel_UpperTF"+(string)Index+"_UpperLineZUK(+10%)",OBJPROP_COLOR,GetChannelColor(Index));
        }
     }

   return;
  }
//+------------------------------------------------------------------+
